package com.casic.dcms.vm;

import androidx.lifecycle.MutableLiveData;

import com.casic.dcms.base.BaseApplication;
import com.casic.dcms.model.ActionResultBean;
import com.casic.dcms.model.MaintainRecordBean;
import com.casic.dcms.utils.StringHelper;
import com.casic.dcms.utils.retrofit.RetrofitServiceManager;
import com.google.gson.Gson;
import com.google.gson.reflect.TypeToken;
import com.pengxh.androidx.lite.callback.OnObserverCallback;
import com.pengxh.androidx.lite.hub.StringHub;
import com.pengxh.androidx.lite.vm.BaseViewModel;
import com.pengxh.androidx.lite.vm.LoadState;
import com.pengxh.androidx.lite.vm.ObserverSubscriber;

import java.io.IOException;
import java.net.ConnectException;

import okhttp3.ResponseBody;
import rx.Observable;

public class BridgeViewModel extends BaseViewModel {
    private final Gson gson = new Gson();
    public MutableLiveData<ActionResultBean> submitResultModel = new MutableLiveData<>();
    public MutableLiveData<MaintainRecordBean> recordModel = new MutableLiveData<>();

    public void submitMaintain(String bridgeId, String content, String maintainTime, String personId, String longitude, String latitude, String description) {
        loadState.setValue(LoadState.Loading);
        Observable<ResponseBody> observable = RetrofitServiceManager.getAddMaintainRecordResult(bridgeId, content, maintainTime, personId, longitude, latitude, description);
        ObserverSubscriber.addSubscribe(observable, new OnObserverCallback() {
            @Override
            public void onCompleted() {
                loadState.setValue(LoadState.Success);
            }

            @Override
            public void onError(Throwable e) {
                loadState.setValue(LoadState.Fail);
                if (e instanceof ConnectException) {
                    StringHub.show(BaseApplication.get(), "连接失败，请检查网络或者服务器");
                } else {
                    StringHub.show(BaseApplication.get(), "服务器异常，请联系管理员");
                }
            }

            @Override
            public void onNext(ResponseBody responseBody) {
                try {
                    String response = responseBody.string();
                    int responseCode = StringHelper.separateResponseCode(response);
                    if (responseCode == 200) {
                        ActionResultBean actionResultBean = gson.fromJson(response, new TypeToken<ActionResultBean>() {
                        }.getType());
                        submitResultModel.setValue(actionResultBean);
                    } else {
                        loadState.setValue(LoadState.Fail);
                        StringHelper.showErrorMessage(response);
                    }
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
        });
    }

    public void obtainMaintainRecord(String startDate, String endDate, int offset) {
        loadState.setValue(LoadState.Loading);
        Observable<ResponseBody> observable = RetrofitServiceManager.getMaintainRecordResult(startDate, endDate, offset);
        ObserverSubscriber.addSubscribe(observable, new OnObserverCallback() {
            @Override
            public void onCompleted() {
                loadState.setValue(LoadState.Success);
            }

            @Override
            public void onError(Throwable e) {
                loadState.setValue(LoadState.Fail);
                if (e instanceof ConnectException) {
                    StringHub.show(BaseApplication.get(), "连接失败，请检查网络或者服务器");
                } else {
                    StringHub.show(BaseApplication.get(), "服务器异常，请联系管理员");
                }
            }

            @Override
            public void onNext(ResponseBody responseBody) {
                try {
                    String response = responseBody.string();
                    int responseCode = StringHelper.separateResponseCode(response);
                    if (responseCode == 200) {
                        MaintainRecordBean resultBean = gson.fromJson(response, new TypeToken<MaintainRecordBean>() {
                        }.getType());
                        recordModel.setValue(resultBean);
                    } else {
                        loadState.setValue(LoadState.Fail);
                        StringHelper.showErrorMessage(response);
                    }
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
        });
    }
}
